config/routes.rb
Rails.application.routes.draw do
  # get 'search/people'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'home#index'
  get 'home/index'

  resources :community_surveys do
    resources :houses do
      resources :family_folders do
        resources :house_health_surveys
        get '/people/search/:id', to: 'people#search'
        resources :people do
          resources :person_health_surveys
          resources :home_visits
        end
      end
    end
  end

  # Address
  get 'addr/update_amphur/:id', to: 'addresses#update_amphur'
  get 'addr/update_tambon/:id', to: 'addresses#update_tambon'

  # Authentication
  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'

  get '/goto_house', to: 'home#house'
  get '/goto_house_health_survey', to: 'home#house_health_survey'
  get '/goto_person', to: 'home#person'
  get '/goto_person_health_survey', to: 'home#person_health_survey'
  get '/goto_home_visit', to: 'home#home_visit'

  get 'communities/search', to: 'community_surveys#search_main'
  resources :diseases

  # Report
  # resources :reports
  # get '/reports', to: 'reports#community_survey'
  get '/reports/overall', to: 'reports#overall'
  get '/reports/community', to: 'reports#community_survey'
  get '/reports/admin/health_survey', to: 'reports#admin_health_survey'
  get '/reports/admin/home_visit', to: 'reports#admin_home_visit'
  get '/reports/admin/houses', to: 'reports#admin_houses'
  get '/reports/admin/people', to: 'reports#admin_people'
  get '/reports/site/health_survey', to: 'reports#site_health_survey'
  get '/reports/site/home_visit', to: 'reports#site_home_visit'
  get '/reports/site/houses', to: 'reports#site_houses'
  get '/reports/site/people', to: 'reports#site_people'

  get '/hospitals', to: 'hospitals#search'
  get '/hospitals/type/:id', to: 'hospitals#by_type'

  # Search
  # get '/search', to: 'search#search_people'
  # Test
  get '/search', to: 'search#people'
end

app/models/community_survey.rb
class CommunitySurvey < ApplicationRecord
  scope :filter_by_vid, -> (vid) { where vid: vid }

  # Hooks Events
  before_create :pre_create
  before_update :pre_update
  after_initialize :init

  # Associate
  belongs_to :addr_changwat
  belongs_to :addr_amphur
  belongs_to :addr_tambon

  # Validation
  validates :vid, allow_blank: true, allow_nil: true, uniqueness: true,
                  length: { minimum: 8, maximum: 14 }
  validates :hospcode, allow_blank: true, length: { minimum: 5, maximum: 5 }
  validates :vname, presence: true
  validates :catm, allow_blank: true, allow_nil: true,
                   length: { minimum: 8, maximum: 8 }
  validates :ctype, presence: true, length: { minimum: 1, maximum: 1 }
  validates :subtype, presence: true, length: { minimum: 2, maximum: 2 }
  validates :commustyle, presence: true, length: { minimum: 1, maximum: 1 }
  validates :dogs, presence: true, length: { minimum: 1, maximum: 1 }
  validates :addr_changwat, allow_blank: true, presence: true
  validates :addr_amphur, allow_blank: true, presence: true
  validates :addr_tambon, allow_blank: true, presence: true
  validates :datesurvey, presence: true
  # validates :nhouse, numericality: { greater_than_or_equal_to: 0 }

  # Enum
  enum commu_style: {
    edge_town: 1,
    crowded: 2,
    housing_estate: 3,
    town: 4,
    community_housing: 5,
    high_building: 6
  }

  private

  def autoid
    site = Site.hospcode hospcode
    no = site.cs_no + 1
    site.update(cs_no: no)
    "#{hospcode}#{no.to_s.rjust(9, '0')}"
  end

  def init
    self.datesurvey = Date.today if datesurvey.nil? && new_record?
    self.addr_changwat_id = 1 if addr_changwat_id.nil? && new_record? # default กทม
  end

  def pre_create
    self.vid = vid || autoid
    reset
    update_u_date
  end

  def pre_update
    reset
    update_u_date
  end

  def update_u_date
    self.u_date = updated_at
  end

  def reset
    if riskenvironment == '2'
      self.riskentype11 = nil
      self.riskentype12 = nil
      self.riskentype13 = nil
    end
  end
end

app/controllers/community_surveys_controller.rb
class CommunitySurveysController < ApplicationController
  include AddressHelper
  skip_before_action :authenticate_user!, only: [:search_main]
  before_action :set_community_survey, only: [:show, :edit, :update, :destroy]
  # GET /community_surveys
  # GET /community_surveys.json
  def index
    @community_surveys = CommunitySurvey.where(hospcode: current_user.hospcode)
                                        .order(created_at: :desc).page page_param
    @community_surveys = @community_surveys.filter_by_vid(params[:vid]) if params[:vid].present?
  end

  # GET /community_surveys/1
  # GET /community_surveys/1.json
  def show
    load_addr @community_survey
  end

  # GET /community_surveys/new
  def new
    @community_survey = CommunitySurvey.new
    load_addr @community_survey
  end

  # GET /community_surveys/1/edit
  def edit
    load_addr @community_survey
  end

  # POST /community_surveys
  # POST /community_surveys.json
  def create
    tambon = AddrTambon.find(community_survey_params.fetch(:addr_tambon_id))
    @community_survey = CommunitySurvey.new(riskentype(community_survey_params.merge(catm: "#{tambon.code}00")))
    respond_to do |format|
      if @community_survey.save
        timestamp = Time.now
        logger.info "[FF] Community Survey [#{@community_survey.id}] created by #{current_user.username} at #{timestamp}"
        AuditLog.create user: current_user.username, category: 'COMMUNITY_SURVEY', action: "created [#{@community_survey.id}] at #{timestamp}"
        format.html do
          redirect_to community_survey_path(@community_survey),
                      notice: t('community_survey.m_created_label')
        end
        format.json { render :show, status: :created, location: @community_survey }
      else
        load_addr @community_survey
        format.html { render :new }
        format.json { render json: @community_survey.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /community_surveys/1
  # PATCH/PUT /community_surveys/1.json
  def update
    respond_to do |format|
      if @community_survey.update(riskentype(community_survey_params))
        timestamp = Time.now
        logger.info "[FF] Community Survey [#{@community_survey.id}] updated by #{current_user.username} at #{timestamp}"
        AuditLog.create user: current_user.username, category: 'COMMUNITY_SURVEY', action: "updated [#{@community_survey.id}] at #{timestamp}"
        format.html do
          redirect_to community_survey_path(@community_survey),
                      notice: t('community_survey.m_updated_label')
        end
        format.json { render :show, status: :ok, location: @community_survey }
      else
        load_addr @community_survey
        format.html { render :edit }
        format.json { render json: @community_survey.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /community_surveys/1
  # DELETE /community_surveys/1.json
  def destroy
    @community_survey.destroy
    timestamp = Time.now
    logger.info "[FF] Community Survey [#{@community_survey.id}] destroyed by #{current_user.username} at #{timestamp}"
    AuditLog.create user: current_user.username, category: 'COMMUNITY_SURVEY', action: "destroyed [#{@community_survey.id}] at #{timestamp}"
    respond_to do |format|
      format.html do
        redirect_to community_surveys_url,
                    notice: t('community_survey.m_deleted_label')
      end
      format.json { head :no_content }
    end
  end

  def search_main
    @main_communities = CommunitySurvey.where(ctype: 1).map(&:vname)
  end

  private

  def riskentype(community_survey_params)
    community_survey_params[:riskentype11].nil? && community_survey_params[:riskentype11] = nil
    community_survey_params[:riskentype12].nil? && community_survey_params[:riskentype12] = nil
    community_survey_params[:riskentype13].nil? && community_survey_params[:riskentype13] = nil
    community_survey_params
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_community_survey
    @community_survey = CommunitySurvey.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def community_survey_params
    datesurvey_param = params.fetch(:community_survey, {}).fetch(:datesurvey)
    params.fetch(:community_survey, {}).merge(hospcode: current_user.hospcode, datesurvey: convert_buddhist_year_to_gregorian_year(datesurvey_param)).permit!
  end
end

app/helpers/community_surveys_helper.rb
module CommunitySurveysHelper
  def ctype_value(value)
    return t(:not_found_label) if value.nil?

    ctype = value == '1' ? 'main' : 'sub'
    t("community_survey.title_type_#{ctype}_label")
  end

  def commustyle_value(value)
    return t(:not_found_label) if value.nil?

    cs_value = CommunitySurvey.commu_styles.invert.fetch(value.to_i)
    t("community_survey.commustyle_#{cs_value}_label")
  end
end

app/views/community_surveys/_main.html.erb
<div class="form-group__input">
  <%= select_tag 'community_survey[mainvid]', options_for_select(@main_communities), 
    { prompt: t('please_select_label'), class: 'ui dropdown', required: true } %>
</div>

app/views/community_surveys/edit.html.erb
<%= render 'form', community_survey: @community_survey, external: false %>
<% content_for :menu_content_title do %>
  <div><%= t 'community_survey.edit_label' %></div>
<% end %>

app/views/community_surveys/index.html.erb
<div class="container">
  <% unless notice.nil? %>
    <div id="notice">
      <div class="ui message icon">
        <i class="close icon"></i>
        <i class="info circle icon"></i>
        <div class="content">
          <%= notice %>
        </div>
      </div>
    </div>
  <% end %>
  <% unless @community_surveys.empty? %>
    <table class="ui table unstackable --responsive">
      <thead>
        <tr>
          <th class="center aligned"><%= t :no_label %></th>
          <th class="center aligned"><%= t 'community_survey.vid_label' %></th>
          <th class="center aligned"><%= t 'community_survey.vname_label' %></th>
          <th class="center aligned"><%= t 'community_survey.type_label' %></th>
          <th class="center aligned"><%= t 'community_survey.commustyle_label' %></th>
          <th class="center aligned"><%= t 'community_survey.nhouse_label' %></th>
          <th class="center aligned"><%= t 'community_survey.nfamily_label' %></th>
          <th class="center aligned"><%= t 'community_survey.nperson_label' %></th>
          <th class="center aligned"><%= t 'community_survey.datesurvey_label' %></th>
          <th class="center aligned"><%= t 'community_survey.u_date' %></th>
          <th colspan="3" class="center aligned"><%= t :actions_label %></th>
        </tr>
      </thead>
      <tbody>
        <% @community_surveys.each_with_index do |community_survey, index| %>
          <tr>
            <td class="center aligned" data-label="<%= t :no_label %>"><%= no(@community_surveys) + index %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.vid_label' %>"><%= community_survey.vid %></td>
            <td class="fixed" data-label="<%= t 'community_survey.vname_label' %>"><%= community_survey.vname %></td>
            <td data-label="<%= t 'community_survey.type_label' %>"><%= ctype_value(community_survey.ctype) %></td>
            <td data-label="<%= t 'community_survey.commustyle_label' %>"><%= commustyle_value(community_survey.commustyle) %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.nhouse_label' %>"><%= community_survey.nhouse %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.nfamily_label' %>"><%= community_survey.nfamily %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.nperson_label' %>"><%= community_survey.nperson %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.datesurvey_label' %>"><%= date_format(community_survey.datesurvey) %></td>
            <td class="center aligned" data-label="<%= t 'community_survey.u_date' %>"><%= date_time_format(community_survey.u_date) %></td>
            <td class="action">
              <%= link_to community_survey, data: { tooltip: t('info_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="info icon"></i>
              <% end %>
              <%= link_to community_survey_houses_path(community_survey), data: { tooltip: t('house.title_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="ico-next-alt"></i>
              <% end %>
              <%= link_to edit_community_survey_path(community_survey), data: { tooltip: t('edit_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="ico-edit"></i>
              <% end %>
              <%= link_to community_survey, method: :delete, data: { confirm: t(:confirm_delete_label), tooltip: t('destroy_label'), position: "bottom right" }, class: "ui button --circle --submit" do %>
                <i class="ico-bin"></i>
              <% end %>
            </td>
          </tr>
        <% end %>
      </tbody>
    </table>
    <div class="pagination">
      <%= paginate @community_surveys %>
    </div>
  <% else %>
    <div class="container__no-content">
      <div>
        <div class="container__no-content --icon">
          <i class="file outline icon"></i>
        </div>
        <div class="container__no-content --text"><%= t('community_survey.title_label_not_found') %></div>
        <div class="container__no-content --button">
          <%= link_to new_community_survey_path, class: "ui button --icon-only" do %>
            <%= t 'community_survey.add_label' %>
          <% end %>
        </div>
      </div>
    </div>
  <% end %>
</div>
<% content_for :menu_content_title do %> 
  <div class="ui breadcrumb">
    <div class="active section"><%= t 'community_survey.title_label' %></div>
    <% if params[:vid].present? %>
      <% content_for :clear_search do %>
        <%= link_to t("clear_search_label"), community_surveys_path, class: "ui button" %>
      <% end %>
    <% end %>
  </div>
<% end %>
<% content_for :menu_content_link do %>
  <%= link_to new_community_survey_path, class: "ui button --icon-only", data: { tooltip: t('community_survey.add_label'), position: "left center" } do %>
    <div class="icon-group">
      <i class="ico-add"></i>
      <i class="ico-community"></i>
    </div>
  <% end %>
<% end %>

app/views/community_surveys/new.html.erb
<%= render 'form', community_survey: @community_survey, external: false %>
<% content_for :menu_content_title do %>
  <div><%= t 'community_survey.add_label' %></div>
<% end %>

app/views/community_surveys/show.html.erb
<% unless notice.nil? %>
  <div id="notice">
    <div class="ui message icon">
      <i class="close icon"></i>
      <i class="info circle icon"></i>
      <div class="content">
        <%= notice %>
      </div>
    </div>
  </div>
<% end %>

<%= render 'community_surveys/info', community_survey: @community_survey %>
<% content_for :menu_content_title do %>
  <div><%= t 'community_survey.title_label' %></div>
<% end %>